// Copyright 2023 schukai GmbH
// SPDX-License-Identifier: AGPL-3.0

package environment

func (e *stateStruct) GetHTMLOutputPath() string {
	return e.sanityConfigPath(e.configuration.Document.HTML.Output)
}

func (e *stateStruct) GetHTMLHTMLTemplatePath(arg string) string {
	if arg != "" {
		return arg
	}

	if e.configuration.Document.HTML.Templates.HTML != "" {
		return e.sanityConfigPath(e.configuration.Document.HTML.Templates.HTML)
	}

	return ""
}

func (e *stateStruct) GetHTMLSinglePageState(arg bool) bool {
	if arg {
		return arg
	}
	return e.configuration.Document.HTML.SinglePage
}

func (e *stateStruct) GetHTMLMetaTitle(arg string) string {
	if arg != "" {
		return arg
	}

	if e.configuration.Document.HTML.Meta.Title != "" {
		return e.configuration.Document.HTML.Meta.Title
	}

	return "documentation"
}

func (e *stateStruct) GetHTMLMetaShortTitle(arg string) string {
	if arg != "" {
		return arg
	}

	if e.configuration.Document.HTML.Meta.ShortTitle != "" {
		return e.configuration.Document.HTML.Meta.ShortTitle
	}

	return "documentation"
}

func (e *stateStruct) GetHTMLMetaLanguage(arg string) string {
	if arg != "" {
		return arg
	}

	if e.configuration.Document.HTML.Meta.Language != "" {
		return e.configuration.Document.HTML.Meta.Language
	}

	return "en"
}

func (e *stateStruct) GetHTMLMetaDescription(arg string) string {
	if arg != "" {
		return arg
	}

	if e.configuration.Document.HTML.Meta.Description != "" {
		return e.configuration.Document.HTML.Meta.Description
	}

	return ""
}

func (e *stateStruct) GetHTMLMetaKeywords(arg string) string {
	if arg != "" {
		return arg
	}

	if e.configuration.Document.HTML.Meta.Keywords != "" {
		return e.configuration.Document.HTML.Meta.Keywords
	}

	return ""
}

func (e *stateStruct) GetHTMLVersion(arg string) string {
	if arg != "" {
		return arg
	}

	if e.configuration.Document.Version != "" {
		return e.configuration.Document.Version
	}

	return ""
}

func (e *stateStruct) GetDocumentHTMLOutputPath(arg string) string {
	if arg != "" {
		return arg
	}

	if e.configuration.Document.HTML.Output != "" {
		return e.sanityConfigPath(e.configuration.Document.HTML.Output)
	}

	return ""
}
